use anyhow::{Context as _, Result, bail};

fn main() -> Result<()> {
    use std::fs;

    let mut args = std::env::args();
    let _exe_name = args.next().context("How do we not have an exe name?")?;
    let mut filenames = vec![];
    for arg in args {
        filenames.push(arg);
    }
    for filename in filenames {
        let metadata = fs::metadata(&filename)?;
        if metadata.is_dir() {
            shell_out("/usr/bin/ls", &filename)?;
        } else {
            shell_out("/usr/bin/cat", &filename)?;
        }
    }
    Ok(())
}

fn shell_out(cmd: &str, arg: &str) -> Result<()> {
    let status = std::process::Command::new(cmd).arg(arg).status()?;
    if !status.success() {
        bail!("subprocess {cmd} failed");
    }
    Ok(())
}
